package rocks.zipcode.quiz5.fundamentals;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * @author leon on 21/12/2018.
 */
public class Calculator {
    public static Double squareRoot(Double value) {
        return Math.sqrt(value);
    }

    public static Double square(Double value) {
        return value * value;
    }

    public static Double[] squareRoots(Double... value) {
        List<Double> output = new ArrayList<>(Arrays.asList(value));

        Double[] doubleArr = new Double[output.size()];

        for(int i = 0; i < output.size(); i++){
            doubleArr[i] = squareRoot(output.get(i));
        }

        return doubleArr;
    }

    public static Double[] squares(Double... values) {
        List<Double> output = new ArrayList<>(Arrays.asList(values));

        Double[] doubleArr = new Double[output.size()];

        for(int i = 0; i < output.size(); i++){
            doubleArr[i] = square(output.get(i));
        }

        return doubleArr;
    }

    public static Double add(Double value1, Double value2) {
        return (value1 + value2);
    }

    public static Double subtract(Double value1, Double value2) {
        return (value1 - value2);
    }


    public static Double divide(Double divisor, Double dividend) {
        return (divisor / dividend);
    }
}
