package rocks.zipcode.quiz5.fundamentals;

import java.util.Arrays;

/**
 * @author leon on 21/12/2018.
 */
public class StringUtils {
    public static Character getMiddleCharacter(String string) {
        return string.charAt(string.length() / 2);
    }

    public static String capitalizeMiddleCharacter(String str) {
        int middle = str.length() / 2;

        char[] chars = str.toCharArray();

        chars[middle] = Character.toUpperCase(chars[middle]);

        return new String(chars);
    }

    public static String lowerCaseMiddleCharacter(String str) {
        int middle = str.length() / 2;

        char[] chars = str.toCharArray();

        chars[middle] = Character.toLowerCase(chars[middle]);

        return new String(chars);
    }

    public static Boolean isIsogram(String str) {
        for(int i = 0; i < str.length(); i++){
            for(int j = 0; j < str.length(); j++){
                if(str.charAt(i) == str.charAt(j) && i != j){
                    return false;
                }
            }
        }
        return true;
    }

    public static Boolean hasDuplicateConsecutiveCharacters(String str) {

        char temp = str.charAt(0);

        if(str.length() > 1) {
            for (int i = 1; i < str.length(); i++) {
                if(str.charAt(i) == temp){
                    return true;
                }
                temp = str.charAt(i);
            }
        }
        return false;
    }

    public static String removeConsecutiveDuplicateCharacters(String str) {
        if(hasDuplicateConsecutiveCharacters(str)){
            String output = "";

            for (int i = 1; i < str.length(); i++) {
                if(str.charAt(i) != str.charAt(i - 1)){
                    output = output + str.charAt(i);
                }
            }
        }
        return str;
    }

    public static String invertCasing(String str) {

        char[] chars = str.toCharArray();

        for (int i = 0; i < chars.length; i++) {
            if(Character.isUpperCase(chars[i])){
                chars[i] = Character.toLowerCase(chars[i]);
            }else{
                chars[i] = Character.toUpperCase(chars[i]);
            }
        }
        return new String(chars);
    }
}