package rocks.zipcode.quiz5.objectorientation.account;

/**
 * @author leon on 27/12/2018.
 */
public class BankAccount extends Account implements Transactable{

    private Double val;

    public BankAccount() {

    }

    public BankAccount(Double val) {
        this.val = val;
    }

    public void setBalance(Double val) {
        this.val = val;
    }

    @Override
    public void deposit(Double amountToIncreaseBy) {
        if(amountToIncreaseBy > 0) {
            setBalance(getBalance() + amountToIncreaseBy);
        }else{
            withdrawal(amountToIncreaseBy);
        }
    }

    @Override
    public void withdrawal(Double amountToDecreaseBy) {
        if(amountToDecreaseBy < 0) {
            setBalance(getBalance() - amountToDecreaseBy);
        }else{
            deposit(amountToDecreaseBy);
        }
    }

    @Override
    public Double getBalance() {
        return this.val;
    }
}
